Skip to main content

## Attribute

# Enum Attribute

Source

    pub enum Attribute {
        NonExhaustive,
        MustUse {
            reason: Option<String>,
        },
        MacroExport,
        ExportName(String),
        LinkSection(String),
        AutomaticallyDerived,
        Repr(AttributeRepr),
        NoMangle,
        TargetFeature {
            enable: Vec<String>,
        },
        Other(String),
    }

Expand description

An attribute, e.g. `#[repr(C)]`

This doesn’t include:

- `#[doc = "Doc Comment"]` or `/// Doc comment`. These are in `Item::docs` instead.
- `#[deprecated]`. These are in `Item::deprecation` instead.

## Variants§

§

### NonExhaustive

`#[non_exhaustive]`

§

### MustUse

`#[must_use]`

#### Fields

§`reason: Option<String>`
§

### MacroExport

`#[macro_export]`

§

### ExportName(String)

`#[export_name = "name"]`

§

### LinkSection(String)

`#[link_section = "name"]`

§

### AutomaticallyDerived

`#[automatically_derived]`

§

### Repr(AttributeRepr)

`#[repr]`

§

### NoMangle

`#[no_mangle]`

§

### TargetFeature

#[target_feature(enable = “feature1”, enable = “feature2”)]

#### Fields

§`enable: Vec<String>`
§

### Other(String)

Something else.

Things here are explicitly not covered by the `FORMAT_VERSION` constant, and may change without bumping the format version.

As an implementation detail, this is currently either:

1. A HIR debug printing, like `"#[attr = Optimize(Speed)]"`
2. The attribute as it appears in source form, like `"#[optimize(speed)]"`.

## Trait Implementations§

Source§

### impl Clone for Attribute

Source§

#### fn clone(&self) -> Attribute

Returns a duplicate of the value. Read more
1.0.0 · Source§

#### fn clone_from(&mut self, source: &Self)

Performs copy-assignment from `source`. Read more
Source§

### impl Debug for Attribute

Source§

#### fn fmt(&self, f: &mut Formatter<'_>) -> Result

Formats the value using the given formatter. Read more
Source§

### impl<'de> Deserialize<'de> for Attribute

Source§

#### fn deserialize<__D>(__deserializer: __D) -> Result<Self, __D::Error>
where __D: Deserializer<'de>,

Deserialize this value from the given Serde deserializer. Read more
Source§

### impl PartialEq for Attribute

Source§

#### fn eq(&self, other: &Attribute) -> bool

Tests for `self` and `other` values to be equal, and is used by `==`.
1.0.0 · Source§

#### fn ne(&self, other: &Rhs) -> bool

Tests for `!=`. The default implementation is almost always sufficient, and should not be overridden without very good reason.
Source§

### impl Serialize for Attribute

Source§

#### fn serialize<__S>(&self, __serializer: __S) -> Result<__S::Ok, __S::Error>
where __S: Serializer,

Serialize this value into the given Serde serializer. Read more
Source§

### impl Eq for Attribute

Source§

### impl StructuralPartialEq for Attribute

## Auto Trait Implementations§

§

### impl Freeze for Attribute

§

### impl RefUnwindSafe for Attribute

§

### impl Send for Attribute

§

### impl Sync for Attribute

§

### impl Unpin for Attribute

§

### impl UnsafeUnpin for Attribute

§

### impl UnwindSafe for Attribute

## Blanket Implementations§

Source§

### impl<T> Any for T
where T: 'static + ?Sized,

Source§

#### fn type_id(&self) -> TypeId

Gets the `TypeId` of `self`. Read more
Source§

### impl<T> Borrow<T> for T
where T: ?Sized,

Source§

#### fn borrow(&self) -> &T

Immutably borrows from an owned value. Read more
Source§

### impl<T> BorrowMut<T> for T
where T: ?Sized,

Source§

#### fn borrow_mut(&mut self) -> &mut T

Mutably borrows from an owned value. Read more
Source§

### impl<T> CloneToUninit for T
where T: Clone,

Source§

#### unsafe fn clone_to_uninit(&self, dest: *mut u8)

🔬This is a nightly-only experimental API. (`clone_to_uninit`)
Performs copy-assignment from `self` to `dest`. Read more
Source§

### impl<T> From<T> for T

Source§

#### fn from(t: T) -> T

Returns the argument unchanged.

Source§

### impl<T, U> Into<U> for T
where U: From<T>,

Source§

#### fn into(self) -> U

Calls `U::from(self)`.

That is, this conversion is whatever the implementation of `From<T> for U` chooses to do.

Source§

### impl<T> ToOwned for T
where T: Clone,

Source§

#### type Owned = T

The resulting type after obtaining ownership.
Source§

#### fn to_owned(&self) -> T

Creates owned data from borrowed data, usually by cloning. Read more
Source§

#### fn clone_into(&self, target: &mut T)

Uses borrowed data to replace owned data, usually by cloning. Read more
Source§

### impl<T, U> TryFrom<U> for T
where U: Into<T>,

Source§

#### type Error = Infallible

The type returned in the event of a conversion error.
Source§

#### fn try_from(value: U) -> Result<T, <T as TryFrom<U>>::Error>

Performs the conversion.
Source§

### impl<T, U> TryInto<U> for T
where U: TryFrom<T>,

Source§

#### type Error = <U as TryFrom<T>>::Error

The type returned in the event of a conversion error.
Source§

#### fn try_into(self) -> Result<U, <U as TryFrom<T>>::Error>

Performs the conversion.
Source§

### impl<T> DeserializeOwned for T
where T: for<'de> Deserialize<'de>,

## Layout§

Note: Most layout information is completely unstable and may even differ between compilations. The only exception is types with certain `repr(...)` attributes. Please see the Rust Reference's “Type Layout” chapter for details on type layout guarantees.

Size: 64 bytes

Size for each variant:

- `NonExhaustive`: 0 bytes
- `MustUse`: 32 bytes
- `MacroExport`: 0 bytes
- `ExportName`: 32 bytes
- `LinkSection`: 32 bytes
- `AutomaticallyDerived`: 0 bytes
- `Repr`: 64 bytes
- `NoMangle`: 0 bytes
- `TargetFeature`: 32 bytes
- `Other`: 32 bytes